//----------------------------------------------------------------------
//EASTRISING TECHNOLOGY CO,.LTD.//
// Module    :  10.1 INCH TFT LCD  1024*600
// Lanuage   : C51 Code
// Create    : JAVEN LIU
// Date      : 2024-10-09
// Drive IC  : RA8879     FLASH:W25Q128JV  W25N01GVZEIG   FONT CHIP:      RTP: XTP2046   CTP:GT9271 
// INTERFACE : 4SPI   
// MCU 		 : STC12LE5C60S2     1T MCU
// MCU VDD	 : 3.3V
// MODULE VDD : 5V OR 3.3V 
//----------------------------------------------------------------------

#include "STC12C5A.h"      
#include <intrins.h>


#include "RA8889_51.h"
#include "RA8889_API_51.h"
#include "RA8889_MCU_IF.h"
#include "UserDef.h"
#include "delay.h"
#include "TP.h"

#include "flash.h"

#include "women_head_80x100.h"


//Graphic_cursor
#include "icon_pen.h"
#include "icon_arrow.h"
#include "icon_busy.h"
#include "icon_no.h"


void gray(void);
void mono_Demo(void);
void Graphic_cursor_initial(void);
void Text_Demo (void);				//
void Geometry_Demo(void);				//λͼʾ
void Show_BMP_NOR(void);						//FLASHBMPͼƬʾ
void Show_JPG_NOR(void);						//FLASHJPGͼƬʾ
void Fade_in_Fade_out_NOR(void);		//ͼƬ뵭ʾ
void Show_AVI_NOR(void);						//FLASHAVIӰƬ
void Show_PNG_NOR(void);						//FLASHPNGͼƬʾ


void NAND_DMA_Demo(void);
void NAND_JPG_Demo(void);
void NAND_AVI_Demo(void);
void Fade_in_Fade_out_NAND(void);
void Show_PNG_NAND(void);

void main()
{

  uchar brightness=10;

	Interface_Init();
	
	/* RA8889Ӳλ */
	RA8889_RST = 1;
	delay_ms(10);
	RA8889_RST = 0;
	delay_ms(10);
	RA8889_RST = 1;


	/* RA8889ʼ */
	RA8889_Initial();
	
 //	Color_Bar_ON();
//	NextStep();
//	Color_Bar_OFF();


  	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
    Foreground_color_65k(White);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1 ,LCD_Height-1);
	Start_Square_Fill();
 
 
 	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);			//趨ָʽ

 	////////BackLight Brightness control test  whit ER's PWM0
	  brightness=10;
	Foreground_color_65k(White);
	Background_color_65k(Red);
	CGROM_Select_Internal_CGROM();  
   	Goto_Text_XY(2,Line1); 
	Show_String( "BackLight Brightness control test");
	 while(brightness<=50)
	  {
		Select_PWM0();
		Set_PWM_Prescaler_1_to_256(20);
	    Select_PWM0_Clock_Divided_By_1();
		Set_Timer0_Count_Buffer(100); 
		Set_Timer0_Compare_Buffer(brightness); 
		Start_PWM0(); 	  	
	  delay_ms(50);
	  brightness+=10;
	 }
 	///////////


	 
	
	/* ѭʾ */
	while(1)
	{ 	

	    TPTEST();
		 
		Text_Demo();				//ֽ
	 	NextStep();
        mono_Demo();
	    NextStep();
		gray();
		NextStep();
		Geometry_Demo();			//λͼʾ
		NextStep();
 


	////Nor Flash
   
		Show_BMP_NOR();						//FLASHBMPͼƬʾ
		NextStep();
		Show_JPG_NOR();						//FLASHJPGͼƬʾ
		NextStep();
		Fade_in_Fade_out_NOR();		//ͼƬ뵭ʾ
		NextStep();		 
		Show_PNG_NOR();						//FLASHPNGͼƬʾ
		NextStep();	
		Show_AVI_NOR();						//FLASHAVIӰƬ
		NextStep();		 								

  
		////NAND Flash

  		NAND_DMA_Demo();
	 	NextStep();

		NAND_JPG_Demo();
 	 	NextStep();

		Fade_in_Fade_out_NAND();		//ͼƬ뵭ʾ
		NextStep();		 

		Show_PNG_NAND();				//FLASHPNGͼƬʾ
		NextStep();

		NAND_AVI_Demo();
	 	NextStep();

	 	
		   
	}
	
}




 

// BTE_Solid_Fill
void mono_Demo(void)
{
  	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 

	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_red,LCD_Width,LCD_Height);	
	NextStep();
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_green,LCD_Width,LCD_Height);	
	NextStep();
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_blue,LCD_Width,LCD_Height);	
	NextStep();
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_yellow,LCD_Width,LCD_Height);	
	NextStep();
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_cyan,LCD_Width,LCD_Height);	
	NextStep();
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_purple,LCD_Width,LCD_Height);	

}


//GRAY
void gray(void)
{ int i,col,line;

  	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 

	 col=0;line=0;
	for(i=0;i<32;i++)
   	{	Foreground_color_65k(i<<11);
		Line_Start_XY(col,line);
		Line_End_XY(col+32,line+LCD_Height/4);
		Start_Square_Fill();
		col+=32;
	}
	  		

	 col=0;line=LCD_Height/4;
	for(i=0;i<64;i+=2)
   	{	Foreground_color_65k(i<<5);
		Line_Start_XY(col,line);
		Line_End_XY(col+32,line+LCD_Height/4);
		Start_Square_Fill();
		col+=32;

	}


	 col=0;line=LCD_Height/2;
	for(i=0;i<32;i++)
   	{	Foreground_color_65k(i);
		Line_Start_XY(col,line);
		Line_End_XY(col+32,line+LCD_Height/4);
		Start_Square_Fill();
		col+=32;
	}

	 col=0;line=(LCD_Height/4)*3;
	for(i=0;i<32;i++)
   	{	Foreground_color_65k((i<<11)+(i<<6)+i);
		Line_Start_XY(col,line);
		Line_End_XY(col+32,line+LCD_Height/4);
		Start_Square_Fill();
		col+=32;
	}
 
}



//Text
void Text_Demo (void)
{	
 	unsigned int i,j;
  	unsigned char code chanese[]={0x6d,0xf1,0x57,0x33,0x65,0xed,0x65,0xe5,0x4e,0x1c,0x65,0xb9,0x79,0xd1,0x62,0x80,0x67,0x09,0x96,0x50,0x51,0x6c,0x53,0xf8,0x00};

    Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Draw_Square(color65k_green,0,0,LCD_Width-1,LCD_Height-1);
	
	 CGROM_Select_Internal_CGROM();
 	Internal_CGROM_Select_ISOIEC8859_1();
	Font_Line_Distance(0);
	Set_Font_to_Font_Width(0);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,1,0);			//趨ָʽ
	Foreground_color_65k(color65k_white);

	
	Draw_Square_Fill(color65k_red,10,10,40,60);
	Draw_Square_Fill(color65k_green,50,10,80,60);
	Draw_Square_Fill(color65k_blue,90,10,120,60);

	Foreground_color_65k(color16M_red);
	

	Goto_Text_XY(10,124);
	Show_String("EastRising");
	Goto_Text_XY(10,148);
	Show_String("www.buydisplay.com");


	Foreground_color_65k(color16M_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//2x

	Goto_Text_XY(10,172);
	Show_String("EastRising");
	Goto_Text_XY(10,220);
	Show_String("www.buydisplay.com");


	Foreground_color_65k(color16M_blue);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,3,3,1,0);			//3x

	Goto_Text_XY(10,268);
	Show_String("EastRising");
	Goto_Text_XY(10,364);
	Show_String("www.buydisplay.com");

 	delay_ms(500);

 

	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);	


	
	Select_SFI_Font_Mode();
	CGROM_Select_Genitop_FontROM();
	SPI_Clock_Period(2);  //SPI_clock= CORE_FREQ / ((Divisor+1)x2)
	Select_SFI_24bit_Address();
	Select_SFI_Single_Mode_Dummy_0T_03h();
	Select_SFI_0();  					
	FONT_DMA_Select_Bus_0();	



#ifdef GT30L32S4W
	GTFont_Select_GT30L32S4W();
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(32,1,1,0,0);
#endif

 	Foreground_color_65k(White);
	Background_color_65k(Red);

	Font_Line_Distance(0);
	Set_Font_to_Font_Width(0);
	Text_Mode();
	
#ifdef GT30L24T3Y
	GTFont_Select_GT30L24T3Y();
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,0,0);

	Foreground_color_65k(Yellow);
	Background_color_65k(0x4410);
	Set_GTFont_Decoder(0x11);  //BIG5
	Goto_Text_XY(0,32+24+4);
	Show_String("Demo BIG5 in GT23L24T3Y:");
	Font_Select_8x16_16x16();
	Goto_Text_XY(0,32+24+4+28);
   	Show_String("qc16x16:RA8876 TFT ϧα");
	Font_Select_12x24_24x24();
	Goto_Text_XY(0,32+24+4+28+20);
   	Show_String("qc16x16:RA8876 TFT ϧα");
#endif


#ifdef GT21L16T1W
	GTFont_Select_GT21L16T1W();
	  Set_GTFont_Decoder(0x11);  //BIG5  
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(16,1,1,0,0);
 	Foreground_color_65k(Yellow);
	Background_color_65k(0x4410);
	Set_GTFont_Decoder(0x11);  //BIG5
	Goto_Text_XY(0,32+24+4);
	Show_String("Demo BIG5 in GT21L16T1W:");
	Font_Select_8x16_16x16();
	Goto_Text_XY(0,32+24+4+28);
   	Show_String("qc16x16:RA8876 TFT ");

#endif

#ifdef GT30L16U2W

	GTFont_Select_GT30L16U2W();

	Set_GTFont_Decoder(0x01);   
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(16,1,1,0,0);
	Font_Select_8x16_16x16();
	Goto_Text_XY(0,32+24+4);
	Show_String("Demo in GT30L16U2W:");

 	Set_GTFont_Decoder(0x18); 
  	Goto_Text_XY(0,32+24+4+20);
	Text_Mode();
	i=0;
	LCD_CmdWrite(0x04);//start write data
	while(chanese[i]!=0){ Check_Mem_WR_FIFO_not_Full();LCD_DataWrite(chanese[i]);i+=1; } Check_2D_Busy();

 #endif

   
	 //GT30L24T3Y    GT30L32S4W 
	Foreground_color_65k(White);
	Background_color_65k(Red);
	Set_GTFont_Decoder(0x01);  //GB2312 
	Goto_Text_XY(0,32+24+4+28+20+28);
	Show_String("Demo GB2312 in External Font IC:");	 
	Font_Select_8x16_16x16();
	Goto_Text_XY(0,32+24+4+28+20+28+28);
	Show_String(" 16x16:ն");
	Font_Select_12x24_24x24();
	Goto_Text_XY(0,32+24+4+28+20+28+28+20);
	Show_String(" 24x24:ն");		  


	Active_Window_XY(0,32+24+4+28+20+28+28+20+28);
	Active_Window_WH(80,100);
	MPU8_16bpp_Memory_Write(0,32+24+4+28+20+28+28+20+28,80,100,women_head_80x100);		
	BTE_Memory_Copy(0,LCD_Width,0,32+24+4+28+20+28+28+20+28,0,0,0,0,0,LCD_Width,80+4,32+24+4+28+20+28+28+20+28,12,80,100);
	BTE_Memory_Copy(0,LCD_Width,0,32+24+4+28+20+28+28+20+28,0,0,0,0,0,LCD_Width,80+4+80+4,32+24+4+28+20+28+28+20+28,12,80,100);

     Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 


	Goto_Text_XY(0,32+24+4+28+20+28+28+20+28+28);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);
	Show_String("ֱ͸ɫ");			


  	 CGROM_Select_Internal_CGROM();
 	Internal_CGROM_Select_ISOIEC8859_1();
  	Foreground_color_65k(Green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,1,0);
	Goto_Text_XY(0,32+24+4+28+20+28+28+20+28);
	Show_String("Demo text transparent write");


	BTE_Solid_Fill(0,LCD_Width,0,32+24+4+28+20+28+28+20+28+104,Black,LCD_Width,139);
	Foreground_color_65k(White); 
	Goto_Text_XY(0,32+24+4+28+20+28+28+20+28+104);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,1,1,1,0);
	Show_String("Demo text cursor:");
	Goto_Text_XY(0,32+24+4+28+20+28+28+20+28+104+28);
	Show_String("C:\\Users\\Administrator\\>");

	//Cursor
	Enable_Text_Cursor_Blinking();
	Blinking_Time_Frames(10);
	Text_Cursor_H_V(15,1);
	Enable_Text_Cursor();
	delay_ms(100);
	Show_String("d");	delay_ms(100);
	Show_String("i");	delay_ms(100);
	Show_String("r");	delay_ms(100);
	Show_String(" ");	delay_ms(100);
	for(i=0;i<14;i++)
	{
		delay_ms(30);
		Text_Cursor_H_V(15-i,1+i);	 
	}
	delay_ms(100);
	Disable_Text_Cursor();
	

	Foreground_color_65k(Green); 
	Goto_Text_XY(0,32+24+4+28+20+28+28+20+28+108+28+24);
	Show_String("Demo graphic cursor:");

	CGROM_Select_Internal_CGROM();	//?????2???a
	Font_Select_12x24_24x24();
	Set_Graphic_Cursor_Color_1(0xff);
	Set_Graphic_Cursor_Color_2(0x00);

	Graphic_cursor_initial();		//?2??D?1a
	Graphic_Cursor_XY(0,32+24+4+28+20+28+28+20+28+108+28+28+28);
	Select_Graphic_Cursor_1();  
	delay_ms(100);
	Select_Graphic_Cursor_2();
	delay_ms(100);
	Select_Graphic_Cursor_3();
	delay_ms(100);
	Select_Graphic_Cursor_4();
	delay_ms(100);
	Select_Graphic_Cursor_1(); 
	
	for(j=0;j<3;j++)
	{
		for(i=0;i<100;i++)
		{
			Graphic_Cursor_XY(i,32+24+4+28+20+28+28+20+28+108+28+28+28-j*50);	
			delay_ms(1);   
	   }
	}
	Graphic_Cursor_XY(0,32+24+4+28+20+28+28+20+28+108+28+28+28);	
	delay_ms(300);
	Disable_Graphic_Cursor();


 
}



void Graphic_cursor_initial(void)
{
  unsigned int i ;

  Memory_Select_Graphic_Cursor_RAM(); 
  Graphic_Mode();

	Select_Graphic_Cursor_1();
	LCD_CmdWrite(0x04);
	for(i=0;i<256;i++)
	{					 
		LCD_DataWrite(gImage_icon_arrow[i]);
	}

	Select_Graphic_Cursor_2();
	LCD_CmdWrite(0x04);
	for(i=0;i<256;i++)
	{					 
		LCD_DataWrite(gImage_icon_busy[i]);
	}

	Select_Graphic_Cursor_3();
	LCD_CmdWrite(0x04);
	for(i=0;i<256;i++)
	{					 
		LCD_DataWrite(gImage_icon_pen[i]);
	}

	Select_Graphic_Cursor_4();
	LCD_CmdWrite(0x04);
	for(i=0;i<256;i++)
	{					 
		LCD_DataWrite(gImage_icon_no[i]);
	}

	Memory_Select_SDRAM();

	Set_Graphic_Cursor_Color_1(0xff);
	Set_Graphic_Cursor_Color_2(0x00);
	Graphic_Cursor_XY(0,0);
	Enable_Graphic_Cursor();
	delay_ms(2);
}




//Geometry
void Geometry_Demo(void)
{ unsigned int i;

 
   	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 

	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_purple);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Geometry drawing.");
	delay_ms(300);
	
	Foreground_color_65k(0x0);
	Square_Start_XY(0,0);
	Square_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();
	
	Draw_Line(color65k_purple,10,10,799-10,479-10);
	Draw_Line(color65k_purple,11,11,799-11,479-11);

	Draw_Triangle(color65k_red,50,0,50,100,150,100);
	Draw_Triangle_Fill(color65k_green,200,0,200,100,300,100);

	Draw_Circle(color65k_blue,400,50,50);
	Draw_Circle_Fill(color65k_white,550,50,50);
	
	Draw_Ellipse(color65k_yellow,100,200,100,50);	
	Draw_Ellipse_Fill(color65k_purple,350,200,100,50);
	
	Draw_Left_Up_Curve(color65k_blue,550,190,50,50);
	Draw_Right_Down_Curve(color65k_white,560,200,50,50);
	Draw_Right_Up_Curve(color65k_red,560,190,50,50);
	Draw_Left_Down_Curve(color65k_yellow,550,200,50,50);

	Draw_Left_Up_Curve_Fill(color65k_blue,700,190,50,50);
	Draw_Right_Down_Curve_Fill(color65k_white,710,200,50,50);
	Draw_Right_Up_Curve_Fill(color65k_red,710,190,50,50);
	Draw_Left_Down_Curve_Fill(color65k_yellow,700,200,50,50);
	
	Draw_Square(color65k_red,50,300,150,400);			    
	Draw_Square_Fill(color65k_red,200,300,300,400);
	
	Draw_Circle_Square(color65k_purple,450,300,550,400,10,10);
	Draw_Circle_Square_Fill(color65k_green,600,300,700,400,10,10);
	
	delay_ms(500);

 	Select_Main_Window_16bpp();
	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	

 	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

   	for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Red);
	Line_Start_XY(0+i,0+i);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1-i);
	Start_Square();
	delay_ms(5);
	}

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Black);
	Line_Start_XY(0+i,0+i);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1-i);
	Start_Square();
	delay_ms(1);
	}
 
///////////////////////////Square Of Circle
   	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

   for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Green);
	Line_Start_XY(0+i,0+i);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1-i);
	Circle_Square_Radius_RxRy(10,10);
	Start_Circle_Square();
	delay_ms(1);
	}

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Black);
	Line_Start_XY(0+i,0+i);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1-i);
	Circle_Square_Radius_RxRy(10,10);
	Start_Circle_Square();
	delay_ms(1);
	}


///////////////////////////Circle
  	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

   for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Blue);
	Circle_Center_XY(LCD_Width/2,LCD_Height/2);
	Circle_Radius_R(i);
	Start_Circle_or_Ellipse();
	delay_ms(1);
	}

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Black);
	Circle_Center_XY(LCD_Width/2,LCD_Height/2);
	Circle_Radius_R(i);
	Start_Circle_or_Ellipse();
	delay_ms(1);
	}


///////////////////////////Ellipse
  	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

   for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(White);
	Circle_Center_XY(LCD_Width/2,LCD_Height/2);
	Ellipse_Radius_RxRy(i+100,i);
	Start_Circle_or_Ellipse();
	delay_ms(1);
	}

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Black);
	Circle_Center_XY(LCD_Width/2,LCD_Height/2);
	Ellipse_Radius_RxRy(i+100,i);
	Start_Circle_or_Ellipse();
	delay_ms(1);
	}


 ////////////////////////////Triangle
   	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Yellow);
	Triangle_Point1_XY(LCD_Width/2,i);
	Triangle_Point2_XY(i,LCD_Height-1-i);
	Triangle_Point3_XY(LCD_Width-1-i,LCD_Height-1-i);
	Start_Triangle();
	delay_ms(1);
	}

    for(i=0;i<=LCD_Height/2-10;i+=8)
	{Foreground_color_65k(Black);
	Triangle_Point1_XY(LCD_Width/2,i);
	Triangle_Point2_XY(i,LCD_Height-1-i);
	Triangle_Point3_XY(LCD_Width-1-i,LCD_Height-1-i);
	Start_Triangle();
	delay_ms(1);
	}



 ////////////////////////////line
   	Foreground_color_65k(Black);
	Line_Start_XY(0,0);
	Line_End_XY(LCD_Width-1,LCD_Height-1);
	Start_Square_Fill();

    for(i=0;i<=LCD_Width;i+=8)
	{Foreground_color_65k(Red);
	Line_Start_XY(i,0);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1);
	Start_Line();
	delay_ms(1);
	}
	for(i=0;i<=LCD_Height;i+=8)
	{Foreground_color_65k(Red);
	Line_Start_XY(0,LCD_Height-1-i);
	Line_End_XY(LCD_Width-1,i);
	Start_Line();
	delay_ms(1);
	}


    for(i=0;i<=LCD_Width;i+=8)
	{Foreground_color_65k(Black);
	Line_Start_XY(i,0);
	Line_End_XY(LCD_Width-1-i,LCD_Height-1);
	Start_Line();
	delay_ms(1);
	}
	for(i=0;i<=LCD_Height;i+=8)
	{Foreground_color_65k(Black);
	Line_Start_XY(0,LCD_Height-1-i);
	Line_End_XY(LCD_Width-1,i);
	Start_Line();
	delay_ms(1);
	}


}	




//NOR_BMP
void Show_BMP_NOR (void)
{
	unsigned char n;

  	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 

	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_red);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of BMP format for nor flash.");
	Goto_Text_XY(10,60);
	Show_String("DMA BMP: FLASH->DISPLAY RAM");
	delay_ms(600);
	

      
  	SPI_NOR_initial_DMA (4,BUS0,CS1,1,0);			    			

	//1~3BMPͼƬ
	for(n=0;n<3;n++)
	{		
		DMA_24bit(2,0,0,LCD_Width,LCD_Height,BINARY_INFO[n].img_width,BINARY_INFO[n].start_addr);
		delay_ms(300);
	}
	

}


//NOR_JPG
void Show_JPG_NOR (void)
{
	unsigned char n;

  	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of JPG format nor flash.");
	Goto_Text_XY(10,60);
	Show_String("DMA JPG: FLASH->DISPLAY RAM");
	delay_ms(600);
	
	SPI_NOR_initial_JPG_AVI(1,0,BUS0,CS1,1);
				
	
	//4~8JPGͼƬ
	for(n=3;n<8;n++)
	{
		JPG_NOR(BINARY_INFO[n].start_addr,BINARY_INFO[n].img_size,LCD_Width,0,0);
		delay_ms(300);
	}
	

}


//NOR_Fade_in_Fade_out
void Fade_in_Fade_out_NOR (void)
{
	unsigned char n,a;

	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width*2);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width*2);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width*2,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Fade in & fade out nor flash.");
	delay_ms(600);
	

  SPI_NOR_initial_JPG_AVI(1,0,BUS0,CS1,1);
					

	//4~8JPGͼƬѭ2Ųйлʾ
	for(n=3;n<7;n++)
	{
		JPG_NOR(BINARY_INFO[n].start_addr,BINARY_INFO[n].img_size,LCD_Width*2,0,LCD_Height);
		JPG_NOR(BINARY_INFO[n+1].start_addr,BINARY_INFO[n+1].img_size,LCD_Width*2,LCD_Width,LCD_Height);
		
		for(a=0;a<=32;a=a+2)
		{
			BTE_Alpha_Blending_Picture_Mode(0,LCD_Width*2,0,LCD_Height,0,LCD_Width*2,LCD_Width,LCD_Height,0,LCD_Width*2, 0,0,LCD_Width,LCD_Height,a);
				delay_ms(20);
		}
	}
	

}


//NOR_AVI
void Show_AVI_NOR (void)
{
	unsigned char temp;

  	
	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_white);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Playing AVI video nor flash.");

    SPI_NOR_initial_JPG_AVI(1,0,BUS0,CS1,1);

	
//	AVI_NOR(BINARY_INFO[9].start_addr,BINARY_INFO[9].img_size,Layer2,Layer3,(LCD_Width-320)/2,(LCD_Height-240)/2,240,320,LCD_Width);
 	AVI_NOR(BINARY_INFO[9].start_addr,BINARY_INFO[9].img_size,Layer2,Layer3,(LCD_Width-600)/2,(LCD_Height-250)/2,250,600,LCD_Width);

	AVI_window(1);
	
	do{	
			temp = Read_Media_Decode_Busy();	//read busy flag to know media decode busy or idle
	}while(temp&0x40);
	AVI_window(0);	 

}


//NOR_PNG
void Show_PNG_NOR (void)
{
	unsigned short n,x,y,dir_x,dir_y;

	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width*2);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width*2);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width*2,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of PNG format nor flash.");
	delay_ms(600);

	SPI_NOR_initial_JPG_AVI(1,0,BUS0,CS1,1);					//ƬѡBUS0,CS1
	JPG_NOR(BINARY_INFO[3].start_addr,BINARY_INFO[3].img_size,LCD_Width*2,0,0);			//Layer0 
	JPG_NOR(BINARY_INFO[3].start_addr,BINARY_INFO[3].img_size,LCD_Width*2,0,LCD_Height);		//Layer1 
	JPG_NOR(BINARY_INFO[3].start_addr,BINARY_INFO[3].img_size,LCD_Width*2,LCD_Width,LCD_Height);	//Layer1 Ҳ

	SPI_NOR_initial_DMA (4,BUS0,CS1,1,0);				//ƬѡBUS0,CS1 ע⣺ʼBMPJPGĲͬ
	SPI_NOR_DMA_png (BINARY_INFO[8].start_addr,Layer4,0,BINARY_INFO[8].img_width,BINARY_INFO[8].img_height);		//8ţPNGͼƬDMAŵLayer4
	
	x=123;
	y=218;			
	dir_x=1;	//PNGƶ0:ݼ1ݽ
	dir_y=1;	//PNGƶ0:ݼ1ݽ
	
	for(n=0;n<300;n++)
	{
		//Դ0=JPGͼƬ   Դ1=PNG
		BTE_alpha_blending_32bit_Pixel_mode(BINARY_INFO[8].img_width,BINARY_INFO[8].img_width,BINARY_INFO[8].img_height,x,y,Layer2,LCD_Width*2,x,y,Layer2,LCD_Width*2,Layer4);	//(S0X,S0Y)<--ͬ-->(desX,desY)PNGչLayer1(x,y)
		BTE_Memory_Copy(Layer2,LCD_Width*2,0,0,0,LCD_Width*2,0,0,Layer0,LCD_Width*2,0,0,0x0C,LCD_Width,LCD_Height);				//Layer1(0,0) -> Layer0(0,0) PNGͼƬcopy
		BTE_Memory_Copy(Layer2,LCD_Width*2,LCD_Width,0,0,LCD_Width*2,0,0,Layer2,LCD_Width*2,0,0,0x0C,LCD_Width,LCD_Height);			//Layer1(800,0) -> Layer1(0,0) ָͼ

		//x͵ݼ
		if(dir_x==1 && x<LCD_Width-400)
		{
			x++;
			if(x==LCD_Width-400-1)	dir_x=0;
		}
		else if(dir_x==0 && x>0)
		{
			x--;
			if(x==0)	dir_x=1;
		}		
		
		//y͵ݼ
		if(dir_y==1 && y<LCD_Height-100)
		{
			y++;
			if(y==LCD_Height-100-1)	dir_y=0;
		}
		else if(dir_y==0 && y>0)
		{
			y--;
			if(y==0)	dir_y=1;
		}
	}	
}
		


/*
NAND flash only support W25N01GVZEIG
*/
void NAND_DMA_Demo(void)
{  unsigned int n;
 
   	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 

	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_red);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of BMP format for nand flash");
	Goto_Text_XY(10,60);
	Show_String("DMA BMP: FLASH->DISPLAY RAM");
	delay_ms(600);
 
 
 	SPI_NAND_initial_DMA (CS2 ,BUS1);
 
 	//1~3BMPͼƬ
	for(n=0;n<3;n++)
	{		
		SPI_NAND_DMA (BINARY_INFO1[n].start_addr,0,0,LCD_Width,LCD_Width,LCD_Height,Layer2,Layer0,0,0x0000);

		delay_ms(300);
	}
}				  	

/*
NAND flash only support W25N01GVZEIG
*/
void NAND_JPG_Demo(void)
{unsigned int n;

   	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of JPG format nand flash.");
	Goto_Text_XY(10,60);
	Show_String("DMA JPG: FLASH->DISPLAY RAM");
	delay_ms(600);

	
	SPI_NAND_initial_JPG_AVI (BUS1,CS2,1);

 	//4~8JPGͼƬ
	for(n=3;n<8;n++)
	{	JPG_NAND (BINARY_INFO1[n].start_addr,BINARY_INFO1[n].img_size,LCD_Width,0,0);
		delay_ms(300);
	}	    
}

/*
NAND flash only support W25N01GVZEIG
*/
void NAND_AVI_Demo(void)
{	unsigned char temp;

	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_blue);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Playing AVI video nand flash.");
	delay_ms(600);


	SPI_NAND_initial_JPG_AVI (BUS1,CS2,1);
	
	AVI_NAND(BINARY_INFO1[9].start_addr,BINARY_INFO1[9].img_size,Layer2,Layer3,0,0,LCD_Width,LCD_Width,LCD_Width);
	//AVI_NAND(BINARY_INFO1[9].start_addr,BINARY_INFO1[9].img_size,shadow_buff,shadow_buff+2400,0,0,250,600,LCD_Width);
	AVI_window(1);
	do{	
			temp = Read_Media_Decode_Busy();	//read busy flag to know media decode busy or idle
		}while(temp&0x40);
	AVI_window(0);
}



//NAND_Fade_in_Fade_out
void Fade_in_Fade_out_NAND (void)
{
	unsigned char n,a;

	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width*2);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width*2);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width*2,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Fade in & fade out nand flash.");
	delay_ms(600);
	

	SPI_NAND_initial_JPG_AVI (BUS1,CS2,1);
					

	//4~8JPGͼƬѭ2Ųйлʾ
	for(n=3;n<7;n++)
	{
		JPG_NAND(BINARY_INFO1[n].start_addr,BINARY_INFO1[n].img_size,LCD_Width*2,0,LCD_Height);
		JPG_NAND(BINARY_INFO1[n+1].start_addr,BINARY_INFO1[n+1].img_size,LCD_Width*2,LCD_Width,LCD_Height);

	

		for(a=0;a<=32;a=a+2)
		{
			BTE_Alpha_Blending_Picture_Mode(0,LCD_Width*2,0,LCD_Height,0,LCD_Width*2,LCD_Width,LCD_Height,0,LCD_Width*2, 0,0,LCD_Width,LCD_Height,a);
				delay_ms(20);
		}
	}
	

}
	

//NAND_PNG
void Show_PNG_NAND (void)
{
	unsigned short n,x,y,dir_x,dir_y;

	Main_Image_Start_Address(Layer0);				
	Main_Image_Width(LCD_Width*2);
	Main_Window_Start_XY(0,0);
	Canvas_Image_Start_address(Layer0);
	Canvas_image_width(LCD_Width*2);
    Active_Window_XY(0,0);
	Active_Window_WH(LCD_Width,LCD_Height);	 
	
	BTE_Solid_Fill(0,LCD_Width*2,0,0,color65k_black,LCD_Width,LCD_Height);
	Foreground_color_65k(color65k_green);
	Select_Font_Height_WxN_HxN_ChromaKey_Alignment(24,2,2,1,0);			//趨ָʽŴ
	Goto_Text_XY(10,10);
	Show_String("Showing picture of PNG format nand flash.");
	delay_ms(600);

	SPI_NAND_initial_JPG_AVI (BUS1,CS2,1);					//ƬѡBUS0,CS1
	JPG_NAND(BINARY_INFO1[4].start_addr,BINARY_INFO1[4].img_size,LCD_Width*2,0,0);			//Layer0 
	JPG_NAND(BINARY_INFO1[4].start_addr,BINARY_INFO1[4].img_size,LCD_Width*2,0,LCD_Height);		//Layer1 
	JPG_NAND(BINARY_INFO1[4].start_addr,BINARY_INFO1[4].img_size,LCD_Width*2,LCD_Width,LCD_Height);	//Layer1 Ҳ

	SPI_NAND_initial_DMA (CS2 ,BUS1);
	SPI_NAND_DMA_png (BINARY_INFO1[8].start_addr,Layer4,0,BINARY_INFO1[8].img_width,BINARY_INFO1[8].img_height);		//8ţPNGͼƬDMAŵLayer4
 
	x=123;
	y=218;			
	dir_x=1;	//PNGƶ0:ݼ1ݽ
	dir_y=1;	//PNGƶ0:ݼ1ݽ
	
	for(n=0;n<300;n++)
	{
		//Դ0=JPGͼƬ   Դ1=PNG
		BTE_alpha_blending_32bit_Pixel_mode(BINARY_INFO1[8].img_width,BINARY_INFO1[8].img_width,BINARY_INFO1[8].img_height,x,y,Layer2,LCD_Width*2,x,y,Layer2,LCD_Width*2,Layer4);	//(S0X,S0Y)<--ͬ-->(desX,desY)PNGչLayer1(x,y)
		BTE_Memory_Copy(Layer2,LCD_Width*2,0,0,0,LCD_Width*2,0,0,Layer0,LCD_Width*2,0,0,0x0C,LCD_Width,LCD_Height);				//Layer1(0,0) -> Layer0(0,0) PNGͼƬcopy
		BTE_Memory_Copy(Layer2,LCD_Width*2,LCD_Width,0,0,LCD_Width*2,0,0,Layer2,LCD_Width*2,0,0,0x0C,LCD_Width,LCD_Height);			//Layer1(800,0) -> Layer1(0,0) ָͼ

		//x͵ݼ
		if(dir_x==1 && x<LCD_Width-400)
		{
			x++;
			if(x==LCD_Width-400-1)	dir_x=0;
		}
		else if(dir_x==0 && x>0)
		{
			x--;
			if(x==0)	dir_x=1;
		}		
		
		//y͵ݼ
		if(dir_y==1 && y<LCD_Height-100)
		{
			y++;
			if(y==LCD_Height-100-1)	dir_y=0;
		}
		else if(dir_y==0 && y>0)
		{
			y--;
			if(y==0)	dir_y=1;
		}
	}	
}


